/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import com.rjconsultores.ventaboletos.entidad.Convenio;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderConvenio;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("busquedaConvenioController")
@Scope("prototype")
public class BusquedaConvenioController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<Convenio> plwConvenio;
    private MyListbox convenioList;
    private Paging pagingConvenio;
    private Textbox txtDescconvenio;
    private Textbox txtCveconvenio;

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        convenioList.setItemRenderer(new RenderConvenio());
        convenioList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                Convenio c = (Convenio) convenioList.getSelected();
                verConvenio(c);
            }
        });

        refreshLista();

        txtDescconvenio.focus();
    }

    private void verConvenio(Convenio c) {
        if (c == null) {
            return;
        }

        Map args = new HashMap();
        args.put("convenio", c);
        args.put("convenioList", convenioList);

        openWindow("/gui/configuraciones_comerciales/editarConvenio.zul",
                Labels.getLabel("editarConvenioController.window.title"),
                args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<Convenio> convenioBusqueda =
                new HibernateSearchObject<Convenio>(Convenio.class,
                pagingConvenio.getPageSize());

        convenioBusqueda.addFilterEqual("activo", Boolean.TRUE);

        convenioBusqueda.addFilterLike("descconvenio",
                "%" + txtDescconvenio.getText().trim().concat("%"));
        convenioBusqueda.addFilterLike("cveconvenio",
                "%" + txtCveconvenio.getText().trim().concat("%"));

        convenioBusqueda.addSortAsc("descconvenio");

        plwConvenio.init(convenioBusqueda, convenioList, pagingConvenio);

        if (convenioList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaConvenioController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verConvenio(new Convenio());
    }
}
